Subject: Re: [PATCH bpf-next 1/3] xdp: Add bulk XDP_TX queue

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Thu, 23 May 2019 13:11:20 +0200

Toshiaki Makita <[email-masked]> writes:

> XDP_TX is similar to XDP_REDIRECT as it essentially redirects packets to
> the device itself. XDP_REDIRECT has bulk transmit mechanism to avoid the
> heavy cost of indirect call but it also reduces lock acquisition on the
> destination device that needs locks like veth and tun.
>
> XDP_TX does not use indirect calls but drivers which require locks can
> benefit from the bulk transmit for XDP_TX as well.

XDP_TX happens on the same device, so there's an implicit bulking
happening because of the NAPI cycle. So why is an additional mechanism
needed (in the general case)?

-Toke